/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.covert.ReportTemplateCovert
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.calculate.domain.vo.report.CalculateDetailVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  com.deepexi.scd.calculate.util.Calculator
 *  com.deepexi.scd.common.enums.business.CalculateObjectEnum
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.deepexi.spa.commons.utils.StringUtils
 *  com.google.api.client.util.Lists
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.deepexi.scd.calculate.covert.ReportTemplateCovert;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.calculate.domain.vo.report.CalculateDetailVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.service.TemplateService;
import com.deepexi.scd.calculate.util.Calculator;
import com.deepexi.scd.common.enums.business.CalculateObjectEnum;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.deepexi.spa.commons.utils.StringUtils;
import com.google.api.client.util.Lists;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Maps;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.function.Function;
import java.util.stream.Collectors;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class IndustryReport07
implements TemplateService {
    private static final Logger log = LoggerFactory.getLogger(IndustryReport07.class);
    private static final String TEMPLATE_NAME = "industryTemplate07.ftl";
    private static final BigDecimal CH4_CO2_CONVER = new BigDecimal("21");
    public static Map<String, String> STANDARD_TOTAL_MAP = Maps.newHashMap();
    public static final List<String> EDGE_LIST;
    public static List<String> metaList;
    public static List<String> tableList;
    public static String EDGE;
    public static String TABLE;
    public static String MAIN;
    public static String META;
    public static String ELECTRIC_HEATING_EDGE;
    public static String NET_INPUT_ELECTRIC;
    public static String NET_INPUT_HEATING;
    public static String INPUT_ELECTRIC;
    public static String INPUT_HEATING;
    public static String OUTPUT_ELECTRIC;
    public static String OUTPUT_HEATING;

    public void exportTemplate(ExportReportLayoutVO exportReportLayoutVO, Map<String, Object> map) {
        List totalList = (List)exportReportLayoutVO.getTotalMap().get("TOTAL");
        List all = (List)exportReportLayoutVO.getTableMap().get("ALL");
        ArrayList newTotalList = Lists.newArrayList();
        newTotalList.addAll(this.getEdgeList(totalList));
        newTotalList.addAll(this.getMetaList(totalList));
        newTotalList.addAll(this.getTableList(totalList));
        newTotalList.addAll(this.getPowerTableList(totalList));
        Map<String, CalculateReportLayoutTotalVO> totalMap = newTotalList.stream().collect(Collectors.toMap(CalculateReportLayoutTotalVO::getTotalName, vo -> {
            if ((vo.getTotalName().contains("甲烷") || vo.getTotalName().contains("CH4") || vo.getTotalName().contains("CH₄")) && vo.getTotalValue() != null) {
                BigDecimal v = vo.getTotalValue().divide(CH4_CO2_CONVER, 2, RoundingMode.HALF_UP);
                vo.setTotalValueStr(ExNumeric.stepFormatValue((BigDecimal)v, (Integer)2));
            }
            return vo;
        }, (a, b) -> a));
        map.put("mainTotals", this.getMain(totalList, newTotalList));
        map.put("totals", totalMap);
        map.put("burnCH4", this.getBurnCH4TableList(all));
        map.put("annexedTable2", this.getAnnexedTable2(all));
        map.put("annexedTable3", this.getAnnexedTable3(all));
        map.put("annexedTable4A", this.getAnnexedTable4A(all));
        map.put("annexedTable4B", this.getAnnexedTable4B(all));
        map.put("annexedTable5", this.getAnnexedTable5(all));
        map.put("annexedTable6", this.getAnnexedTable6(all));
        map.put("annexedTable7", this.getAnnexedTable7(all));
        map.put("annexedTable8A", this.getAnnexedTable8A(all));
        map.put("annexedTable8B", this.getAnnexedTable8B(all));
        map.put("annexedTable9", this.getAnnexedTable9(all));
        map.put("annexedTable10", this.getAnnexedTable10(all));
        map.put("annexedTable11A", this.getAnnexedTable11A(all));
        map.put("annexedTable11B", this.getAnnexedTable11B(all));
        map.put("annexedTable12", this.getAnnexedTable12(all));
        map.put("annexedTable13", this.getAnnexedTable13(all));
        map.put("annexedTable14", this.getAnnexedTable14(all));
        map.put("list", exportReportLayoutVO);
        map.put("tplName", TEMPLATE_NAME);
    }

    public String getTemplateName() {
        return TEMPLATE_NAME;
    }

    private List<CalculateReportLayoutTotalVO> getMain(List<CalculateReportLayoutTotalVO> all, List<CalculateReportLayoutTotalVO> totalList) {
        ArrayList result = Lists.newArrayList();
        BigDecimal mainCount = BigDecimal.ZERO;
        BigDecimal electricHeatingCount = BigDecimal.ZERO;
        for (CalculateReportLayoutTotalVO vo : all) {
            if (!"企业二氧化碳排放总量".equals(vo.getTotalName()) || !MAIN.equals(vo.getTotalType()) || !"TOTAL".equals(vo.getTotalCategory())) continue;
            mainCount = this.convert2BigDecimal(vo.getTotalValueStr());
            break;
        }
        for (CalculateReportLayoutTotalVO vo : totalList) {
            if (!vo.getTotalName().contains("净购入")) continue;
            electricHeatingCount = electricHeatingCount.add(this.convert2BigDecimal(vo.getTotalValueStr()));
        }
        CalculateReportLayoutTotalVO electricHeatingCountTotal = new CalculateReportLayoutTotalVO();
        electricHeatingCountTotal.setTotalName("不包括净购入电力和热力隐含的CO₂排放");
        electricHeatingCountTotal.setTotalValueStr(ExNumeric.formatValue((BigDecimal)mainCount.subtract(electricHeatingCount), (Integer)2));
        result.add(electricHeatingCountTotal);
        CalculateReportLayoutTotalVO allCountTotal = new CalculateReportLayoutTotalVO();
        allCountTotal.setTotalName("包括净购入电力和热力隐含的CO₂排放");
        allCountTotal.setTotalValueStr(ExNumeric.formatValue((BigDecimal)mainCount, (Integer)2));
        result.add(allCountTotal);
        return result;
    }

    private List<CalculateReportLayoutTotalVO> getEdgeList(List<CalculateReportLayoutTotalVO> totalList) {
        List edgeObjectsList = totalList.stream().filter(item -> CalculateObjectEnum.EDGE.name().equals(item.getTotalType()) && EDGE_LIST.contains(item.getTotalName())).collect(Collectors.toList());
        return ReportTemplateCovert.covertTotalList((String)CalculateObjectEnum.EDGE.name(), EDGE_LIST, STANDARD_TOTAL_MAP, edgeObjectsList);
    }

    private List<CalculateReportLayoutTotalVO> getMetaList(List<CalculateReportLayoutTotalVO> totalList) {
        List<CalculateReportLayoutTotalVO> metaObjectsList = totalList.stream().filter(item -> META.equals(item.getTotalType()) && metaList.contains(item.getTotalName())).collect(Collectors.toList());
        return this.getList(META, metaList, metaObjectsList);
    }

    private List<CalculateReportLayoutTotalVO> getTableList(List<CalculateReportLayoutTotalVO> totalList) {
        List<CalculateReportLayoutTotalVO> tableObjectsList = totalList.stream().filter(item -> TABLE.equals(item.getTotalType()) && tableList.contains(item.getTotalName())).collect(Collectors.toList());
        return this.getList(META, tableList, tableObjectsList);
    }

    private BigDecimal getBurnCH4TableList(List<CalculateReportLayoutObjectVO> all) {
        ImmutableList<String> keyArray0 = ImmutableList.of("正常工况火炬气流量", "火炬气中甲烷体积浓度", "碳氧化率");
        String formula0 = "正常工况火炬气流量*火炬气中甲烷体积浓度/100*(1-碳氧化率/100)*7.17";
        BigDecimal total0 = BigDecimal.ZERO;
        List list0 = ReportTemplateCovert.getTableItems(all, ImmutableList.of("火炬燃烧"), ImmutableList.of("石油天然气火炬燃烧"), ImmutableList.of("石油天然气正常工况火炬燃烧"), null, null, null);
        for (CalculateReportLayoutObjectVO objectVO : list0) {
            for (CalculateLayoutItemVO itemVO : objectVO.getItemList()) {
                HashMap<String, String> calcMap = new HashMap<String, String>();
                for (CalculateLayoutItemValueVO valueVO : itemVO.getItemValueList()) {
                    String key = valueVO.getValueCode();
                    if (!keyArray0.contains(key)) continue;
                    BigDecimal value = this.convert2BigDecimal(valueVO.getValue());
                    calcMap.put(key, value.toString());
                }
                BigDecimal calcEnd = Calculator.conversion((String)formula0, calcMap, (Integer)2);
                if (calcEnd == null) continue;
                total0 = total0.add(calcEnd);
            }
        }
        ImmutableList<String> keyArray1 = ImmutableList.of("事故平均火炬气流速度", "事故的持续时长", "火炬气中甲烷的体积浓度", "碳氧化率");
        String formula1 = "事故平均火炬气流速度*事故的持续时长*火炬气中甲烷的体积浓度/100*(1-碳氧化率/100)*7.17";
        BigDecimal total1 = BigDecimal.ZERO;
        List list1 = ReportTemplateCovert.getTableItems(all, ImmutableList.of("火炬燃烧"), ImmutableList.of("石油天然气火炬燃烧"), ImmutableList.of("石油天然气事故火炬燃烧"), null, null, null);
        for (CalculateReportLayoutObjectVO objectVO : list1) {
            for (CalculateLayoutItemVO itemVO : objectVO.getItemList()) {
                HashMap<String, String> calcMap = new HashMap<String, String>();
                for (CalculateLayoutItemValueVO valueVO : itemVO.getItemValueList()) {
                    String key = valueVO.getValueCode();
                    if (!keyArray1.contains(key)) continue;
                    BigDecimal value = this.convert2BigDecimal(valueVO.getValue());
                    calcMap.put(key, value.toString());
                }
                BigDecimal calcEnd = Calculator.conversion((String)formula1, calcMap, (Integer)2);
                if (calcEnd == null) continue;
                total1 = total1.add(calcEnd);
            }
        }
        return total0.add(total1);
    }

    private List<CalculateReportLayoutTotalVO> getPowerTableList(List<CalculateReportLayoutTotalVO> totalList) {
        Optional<CalculateReportLayoutTotalVO> inputElectric = totalList.stream().filter(item -> TABLE.equals(item.getTotalType()) && item.getTotalName().contains(INPUT_ELECTRIC)).findFirst();
        Optional<CalculateReportLayoutTotalVO> inputHeating = totalList.stream().filter(item -> TABLE.equals(item.getTotalType()) && item.getTotalName().contains(INPUT_HEATING)).findFirst();
        BigDecimal inputElectricSum = inputElectric.isPresent() ? this.convert2BigDecimal(inputElectric.get().getTotalValueStr()) : BigDecimal.ZERO;
        BigDecimal inputHeatingSum = inputHeating.isPresent() ? this.convert2BigDecimal(inputHeating.get().getTotalValueStr()) : BigDecimal.ZERO;
        Optional<CalculateReportLayoutTotalVO> outputElectric = totalList.stream().filter(item -> TABLE.equals(item.getTotalType()) && item.getTotalName().contains(OUTPUT_ELECTRIC)).findFirst();
        Optional<CalculateReportLayoutTotalVO> outputHeating = totalList.stream().filter(item -> TABLE.equals(item.getTotalType()) && item.getTotalName().contains(OUTPUT_HEATING)).findFirst();
        BigDecimal outputElectricSum = outputElectric.isPresent() ? this.convert2BigDecimal(outputElectric.get().getTotalValueStr()) : BigDecimal.ZERO;
        BigDecimal outputHeatingSum = outputHeating.isPresent() ? this.convert2BigDecimal(outputHeating.get().getTotalValueStr()) : BigDecimal.ZERO;
        CalculateReportLayoutTotalVO electric = new CalculateReportLayoutTotalVO();
        BigDecimal e = outputElectricSum.compareTo(BigDecimal.ZERO) > 0 ? inputElectricSum.subtract(outputElectricSum) : inputElectricSum.add(outputElectricSum);
        electric.setTotalValueStr(ExNumeric.formatValue((BigDecimal)e, (Integer)2));
        electric.setTotalValue(e);
        electric.setTotalName("净购入电力隐含的 CO2 排放");
        CalculateReportLayoutTotalVO heating = new CalculateReportLayoutTotalVO();
        BigDecimal h = outputHeatingSum.compareTo(BigDecimal.ZERO) > 0 ? inputHeatingSum.subtract(outputHeatingSum) : inputHeatingSum.add(outputHeatingSum);
        heating.setTotalValueStr(ExNumeric.formatValue((BigDecimal)h, (Integer)2));
        heating.setTotalValue(h);
        heating.setTotalName("净购入热力隐含的 CO2 排放");
        ArrayList result = Lists.newArrayList();
        result.add(electric);
        result.add(heating);
        return result;
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable2(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("化石燃料燃烧"), ImmutableList.of("化石燃料燃烧-石油和天然气（重点燃烧设施）"), ImmutableList.of("化石燃料燃烧-石油和天然气（重点燃烧设施）"), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable3(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("化石燃料燃烧"), ImmutableList.of("化石燃料燃烧-石油和天然气（其它燃烧设施）"), ImmutableList.of("化石燃料燃烧-石油和天然气（其它燃烧设施）"), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable4A(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("火炬燃烧"), ImmutableList.of("石油天然气火炬燃烧"), ImmutableList.of("石油天然气正常工况火炬燃烧"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable4B(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("火炬燃烧"), ImmutableList.of("石油天然气火炬燃烧"), ImmutableList.of("石油天然气事故火炬燃烧"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable5(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气勘探温室气体排放"), ImmutableList.of("油气勘探工艺直接放空甲烷排放"), null, null, null);
    }

    private Map<String, List<CalculateReportLayoutObjectVO>> getAnnexedTable6(List<CalculateReportLayoutObjectVO> all) {
        List voList = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气开采温室气体排放"), ImmutableList.of("油气开采工艺放空甲烷排放"), null, null, null);
        ImmutableMap<String, String> nameMap = ImmutableMap.of("石油系统", "石油开采", "天然气系统", "天然气开采");
        HashMap<String, List<CalculateReportLayoutObjectVO>> map = Maps.newHashMap();
        for (CalculateReportLayoutObjectVO vo : voList) {
            for (CalculateLayoutItemVO itemVo : vo.getItemList()) {
                String itemName = itemVo.getItemName();
                String[] keys = itemName.split("-");
                if (keys.length != 3 || !nameMap.containsKey(keys[0]) || !keys[1].endsWith("开采")) continue;
                String key = (String)nameMap.get(keys[0]);
                CalculateReportLayoutObjectVO temp = new CalculateReportLayoutObjectVO();
                temp.setItemList(Collections.singletonList(itemVo));
                if (map.containsKey(key)) {
                    ((List)map.get(key)).add(temp);
                    continue;
                }
                ArrayList<CalculateReportLayoutObjectVO> newList = new ArrayList<CalculateReportLayoutObjectVO>();
                newList.add(temp);
                map.put(key, newList);
            }
        }
        return map;
    }

    private Map<String, List<CalculateReportLayoutObjectVO>> getAnnexedTable7(List<CalculateReportLayoutObjectVO> all) {
        List voList = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气开采温室气体排放"), ImmutableList.of("油气开采甲烷逃逸排放"), null, null, null);
        ImmutableMap<String, String> nameMap = ImmutableMap.of("石油系统", "石油开采", "天然气系统", "天然气开采");
        HashMap<String, List<CalculateReportLayoutObjectVO>> map = Maps.newHashMap();
        for (CalculateReportLayoutObjectVO vo : voList) {
            for (CalculateLayoutItemVO itemVo : vo.getItemList()) {
                String itemName = itemVo.getItemName();
                String[] keys = itemName.split("-");
                if (keys.length != 3 || !nameMap.containsKey(keys[0]) || !keys[1].endsWith("开采")) continue;
                String key = (String)nameMap.get(keys[0]);
                CalculateReportLayoutObjectVO temp = new CalculateReportLayoutObjectVO();
                temp.setItemList(Collections.singletonList(itemVo));
                if (map.containsKey(key)) {
                    ((List)map.get(key)).add(temp);
                    continue;
                }
                ArrayList<CalculateReportLayoutObjectVO> newList = new ArrayList<CalculateReportLayoutObjectVO>();
                newList.add(temp);
                map.put(key, newList);
            }
        }
        return map;
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable8A(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气处理温室气体排放"), ImmutableList.of("天然气处理工艺放空甲烷排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable8B(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气处理温室气体排放"), ImmutableList.of("天然气处理工艺放空二氧化碳排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable9(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气处理温室气体排放"), ImmutableList.of("油气处理甲烷逃逸排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable10(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气储运温室气体排放"), ImmutableList.of("油气储运工艺放空甲烷排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable11A(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气储运温室气体排放"), ImmutableList.of("油气储运原油运输甲烷逃逸排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable11B(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("油气储运温室气体排放"), ImmutableList.of("油气储运天然气甲烷逃逸排放"), null, null, null);
    }

    private Map<String, BigDecimal> getAnnexedTable12(List<CalculateReportLayoutObjectVO> all) {
        List voList = ReportTemplateCovert.getTableItems(all, ImmutableList.of("回收扣除"), ImmutableList.of("CH₄回收利用量"), ImmutableList.of("CH₄回收利用量"), null, null, null);
        return this.getAnnexedTableAvg(voList);
    }

    private Map<String, BigDecimal> getAnnexedTable13(List<CalculateReportLayoutObjectVO> all) {
        List voList = ReportTemplateCovert.getTableItems(all, ImmutableList.of("回收扣除"), ImmutableList.of("CO₂回收利用量"), ImmutableList.of("CO₂回收利用量"), null, null, null);
        return this.getAnnexedTableAvg(voList);
    }

    private Map<String, Map<String, String>> getAnnexedTable14(List<CalculateReportLayoutObjectVO> all) {
        List<CalculateLayoutItemVO> result = this.getFilterItem(all, ImmutableList.of("电力热力"), ImmutableList.of("购入输出电力热力"), ImmutableList.of("购入电力", "购入热力", "输出电力", "输出热力"));
        ImmutableList<String> array = ImmutableList.of("购入", "输出");
        ImmutableList<String> defaultNameArrays = ImmutableList.of("购入电力", "购入热力", "购入蒸汽", "购入热水", "输出电力", "输出热力", "输出蒸汽", "输出热水");
        HashMap<String, Map<String, String>> map = new HashMap<String, Map<String, String>>();
        result.forEach(vo -> {
            Map childMap;
            String itemName = vo.getItemName();
            String key = itemName;
            if (defaultNameArrays.contains(key)) {
                key = itemName.replaceAll("购入", "").replaceAll("输出", "");
            }
            Map map2 = childMap = map.containsKey(key) ? (Map)map.get(key) : new HashMap();
            if (childMap != null) {
                vo.getItemValueList().forEach(value -> {
                    for (String str : array) {
                        if (!vo.getTableName().contains(str)) continue;
                        childMap.put(str.concat(value.getValueCode()), value.getValue());
                    }
                });
                map.put(key, childMap);
            }
        });
        map.forEach((k, v) -> {
            String inputStr = (String)v.get("购入购入量");
            String outputStr = (String)v.get("输出输出量");
            BigDecimal input = this.convert2BigDecimal(inputStr);
            BigDecimal output = this.convert2BigDecimal(outputStr);
            BigDecimal difference = input.subtract(output);
            v.put("净购入消耗量", difference.toString());
            CalculateDetailVO calculateDetailVO = new CalculateDetailVO();
            BigDecimal inputFactor = this.convert2BigDecimal((String)v.get("购入排放因子"));
            BigDecimal outputFactor = this.convert2BigDecimal((String)v.get("输出排放因子"));
            if (inputFactor != null) {
                calculateDetailVO.add(inputFactor);
            }
            if (outputFactor != null) {
                calculateDetailVO.add(outputFactor);
            }
            v.put("排放因子", calculateDetailVO.getAvg(5, RoundingMode.HALF_UP).stripTrailingZeros().toPlainString());
        });
        return map;
    }

    private Map<String, BigDecimal> getAnnexedTableAvg(List<CalculateReportLayoutObjectVO> voList) {
        HashMap<String, CalculateDetailVO> calcMap = new HashMap<String, CalculateDetailVO>();
        HashMap<String, BigDecimal> resultMap = new HashMap<String, BigDecimal>();
        for (CalculateReportLayoutObjectVO objectVO : voList) {
            for (CalculateLayoutItemVO itemVO : objectVO.getItemList()) {
                for (CalculateLayoutItemValueVO valueVO : itemVO.getItemValueList()) {
                    String key = valueVO.getValueCode();
                    if ("核算项".equals(key)) continue;
                    CalculateDetailVO calculateDetailVO = calcMap.containsKey(key) ? (CalculateDetailVO)calcMap.get(key) : new CalculateDetailVO();
                    calculateDetailVO.add(this.convert2BigDecimal(valueVO.getValue()));
                    calcMap.put(key, calculateDetailVO);
                }
            }
        }
        calcMap.forEach((k, v) -> resultMap.put((String)k, k.contains("度") ? v.getAvg(5, RoundingMode.HALF_UP) : v.getTotal()));
        return resultMap;
    }

    private List<CalculateLayoutItemVO> getFilterItem(List<CalculateReportLayoutObjectVO> all, List<String> edgeNames, List<String> metaNames, List<String> tableNames) {
        return all.stream().filter(item -> edgeNames.contains(item.getUpperObjectName())).filter(item -> metaNames.contains(item.getObjectName())).flatMap(item -> item.getItemList().stream()).filter(item -> tableNames.contains(item.getTableName())).collect(Collectors.toList());
    }

    private List<CalculateReportLayoutTotalVO> getList(String type, List<String> list, List<CalculateReportLayoutTotalVO> totalList) {
        Map totalMap = totalList.stream().collect(Collectors.toMap(CalculateReportLayoutTotalVO::getTotalName, Function.identity(), (a, b) -> a));
        return list.stream().map(name -> {
            CalculateReportLayoutTotalVO calculateReportLayoutTotalVO = (CalculateReportLayoutTotalVO)totalMap.get(name);
            if (Objects.isNull(calculateReportLayoutTotalVO)) {
                calculateReportLayoutTotalVO = new CalculateReportLayoutTotalVO();
                calculateReportLayoutTotalVO.setTotalValueStr("0");
                calculateReportLayoutTotalVO.setTotalType(type);
            }
            calculateReportLayoutTotalVO.setTotalName(name);
            calculateReportLayoutTotalVO.setExtend(Maps.newHashMap());
            return calculateReportLayoutTotalVO;
        }).collect(Collectors.toList());
    }

    private BigDecimal convert2BigDecimal(String value) {
        if (StringUtils.isBlank((CharSequence)value)) {
            return BigDecimal.ZERO;
        }
        return new BigDecimal(value.replace(",", ""));
    }

    static {
        STANDARD_TOTAL_MAP.put("化石燃料燃烧排放量", "燃料燃烧 CO2 排放");
        STANDARD_TOTAL_MAP.put("火炬燃烧直接二氧化碳排放排放量", "火炬燃烧 CO2 排放");
        STANDARD_TOTAL_MAP.put("工业过程二氧化碳排放排放量", "工业生产过程 CO2 排放");
        EDGE_LIST = ImmutableList.of("化石燃料燃烧排放量");
        metaList = ImmutableList.of("石油天然气火炬燃烧排放量");
        tableList = ImmutableList.of("油气勘探工艺直接放空甲烷排放排放量", "油气开采工艺放空甲烷排放排放量", "天然气处理工艺放空甲烷排放排放量", "油气储运工艺放空甲烷排放排放量", "天然气处理工艺放空二氧化碳排放排放量", "油气开采甲烷逃逸排放排放量", "油气处理甲烷逃逸排放排放量", "油气储运原油运输甲烷逃逸排放排放量", "油气储运天然气甲烷逃逸排放排放量", "CH₄回收利用量排放量", "CO₂回收利用量排放量");
        EDGE = "EDGE";
        TABLE = "TABLE";
        MAIN = "MAIN";
        META = "META";
        ELECTRIC_HEATING_EDGE = "电力热力";
        NET_INPUT_ELECTRIC = "净购入电力";
        NET_INPUT_HEATING = "净购入热力";
        INPUT_ELECTRIC = "购入电力";
        INPUT_HEATING = "购入热力";
        OUTPUT_ELECTRIC = "输出电力";
        OUTPUT_HEATING = "输出热力";
    }
}

